LEDS		EQU	8000H		; endereo do perifrico dos LEDs
ESPERA	EQU	150		; valor de espera (depende do desempenho do
					; computador que executa o simulador)

PLACE		1000H			; zona de dados
pilhaPP:	TABLE		30	; pilha para o programa principal
fimPilhaPP:				; valor de inicializao do SP do prog. principal
valorLEDs:	WORD		0	; imagem na memria do valor dos LEDs
estPisca:	WORD		0	; palavra com o estado do processo Pisca
estAlt:		WORD		0	; palavra com o estado do processo Alterna
contPisca:	WORD		0	; contador de espera do processo Pisca
contAlt:	WORD		0	; contador de espera do processo Alterna

PLACE		0000H		; programa principal, inicializaes, etc.
incio:
	MOV	SP, fimPilhaPP	; inicializa SP com pilha do programa principal
	MOV	R8, valorLEDs	; imagem na memria do valor dos LEDs
	MOV	R9, LEDS	; endereo do perifrico dos LEDs
	MOV	R0, 0
	MOV	[R8], R0	; inicializa imagem na memria do valor dos LEDs
	MOV	R1, estPisca
	MOV	[R1], R0	; inicializa estado do processo Pisca
	MOV	R1, estAlt
	MOV	[R1], R0	; inicializa estado do processo Alterna
ciclo:
	CALL	Pisca		; executa uma iterao do processo Pisca
	CALL	Alterna	; executa uma iterao do processo Alterna
	JMP	ciclo		; repete o ciclo

; processo que pisca o LED 0
Pisca:
	MOV	R1, estPisca
	MOV	R0, [R1]	; v em que estado est
	CMP	R0, 0		; estado 0?
	JZ	Pisca0
	CMP	R0, 1		; estado 1?
	JZ	Pisca1
	RET			; se chegar aqui, houve algum erro!		
Pisca0:				; estado 0
	MOV	R0, ESPERA
	MOV	R2, contPisca
	MOV	[R2], R0	; inicializa contador de espera
	MOV	R0, [R8]	; l imagem na memria do valor dos LEDs
	SET	R0, 0		; inicializa o bit 0 (LED deste processo)
	MOV	[R8], R0	; actualiza imagem na memria do valor dos LEDs
	MOVB	[R9],	R0 	; actualiza valor dos LEDs no perifrico
	MOV	R0, 1
	MOV	R1, estPisca
	MOV	[R1], R0	; prximo estado  o 1
	RET			; passa ao processo seguinte
Pisca1:				; estado 1
	MOV	R2, contPisca
	MOV	R0, [R2]	; l contador de espera
	SUB	R0, 1		; e decrementa-o
	MOV	[R2], R0	; actualiza contador de espera
	JNZ	fimP1		; se ainda no chegou a zero, vai iterar de novo
	MOV	R0, ESPERA
	MOV	[R2], R0	; reinicializa contador de espera
	MOV	R0, [R8]	; l imagem na memria do valor dos LEDs
	CPL	R0, 0		; troca o bit 0 (LED deste processo)
	MOV	[R8], R0	; actualiza imagem na memria do valor dos LEDs
	MOVB	[R9],	R0 	; actualiza valor dos LEDs no perifrico
fimP1:	RET			; passa ao processo seguinte
			
; processo que liga alternadamente os LEDs 2 e 3
Alterna:
	MOV	R1, estAlt
	MOV	R0, [R1]	; v em que estado est
	CMP	R0, 0
	JZ	Alt0		; estado 0?
	CMP	R0, 1
	JZ	Alt1		; estado 1?
	CMP	R0, 2
	JZ	Alt2		; estado 2?
	RET			; se chegar aqui, houve algum erro!
Alt0:				; estado 0
	MOV	R0, ESPERA
	MOV	R2, contAlt
	MOV	[R2], R0	; inicializa contador de espera
	MOV	R0, 1
	MOV	R1, estAlt
	MOV	[R1], R0	; prximo estado  o 1
	RET			; passa ao processo seguinte
Alt1:				; estado 2
	MOV	R2, contAlt
	MOV	R0, [R2]	; l contador de espera
	SUB	R0, 1		; e decrementa-o
	MOV	[R2], R0	; actualiza contador de espera
	JNZ	fimA1		; se ainda no chegou a zero, vai iterar de novo
	MOV	R0, ESPERA
	MOV	[R2], R0	; actualiza contador de espera
	MOV	R0, [R8]	; l imagem na memria do valor dos LEDs
	SET	R0, 2		; fora os bits 2 e 3 (LEDs deste processo)
	CLR	R0, 3	
	MOV	[R8], R0	; actualiza imagem na memria do valor dos LEDs
	MOVB	[R9],	R0 	; actualiza valor dos LEDs no perifrico
	MOV	R0, 2
	MOV	R1, estAlt
	MOV	[R1], R0	; prximo estado  o 2
fimA1:
	RET			; passa ao processo seguinte
Alt2:				; estado 2
	MOV	R2, contAlt
	MOV	R0, [R2]	; l contador de espera
	SUB	R0, 1		; e decrementa-o
	MOV	[R2], R0	; actualiza contador de espera
	JNZ	fimA2		; se ainda no chegou a zero, vai iterar de novo
	MOV	R0, ESPERA
	MOV	[R2], R0	; reinicializa contador de espera
	MOV	R0, [R8]	; l imagem na memria do valor dos LEDs
	CLR	R0, 2		; fora os bits 2 e 3 (LEDs deste processo)
	SET	R0, 3	
	MOV	[R8], R0	; actualiza imagem na memria do valor dos LEDs
	MOVB	[R9],	R0 	; actualiza valor dos LEDs no perifrico
	MOV	R0, 1
	MOV	R1, estAlt
	MOV	[R1], R0	; prximo estado  o 1

	MOV	R0, 3000H	; ciclo artificial, s para demorar tempo
maisUm:
	SUB	R0, 1	
	JNZ	maisUm

fimA2:
	RET			; passa ao processo seguinte
